
TYPO3.Flow - Feature # 49522

Status: Resolved Priority: Should have
Author: Alexander Berl Category: Security
Created: 2013-06-29 Assigned To: Alexander Berl
Updated: 2015-06-01 Due date:
PHP Version:
Has patch: No
Complexity:
Subject: Add request patterns for IP and host name
Description

A very common scenario for authentication providers and firewall setups is to check for specific IPs/IP ranges or host names.
Hence Flow should ship with RequestPatterns for those cases.

Associated revisions
Revision 91dd1765 - 2015-06-01 12:45 - Alexander Berl

[FEATURE] Request patterns for host name and IP addresses

This change adds RequestPatterns for host name and IP addresses.
Host names are configurable with a simple wildcard ('*') pattern, IP
addresses use ``CIDR`` style pattern with support for both ``IPv4`` and
``IPv6`` following ``RFC4632`` and ``RFC4291``.

Examples:

Only grant access to clients with IPs from 192.168.178.0 to
192.168.178.255::

TYPO3:
    Flow:
      security:
        firewall:
          rejectAll: TRUE
          filters:
            'ip':
              patternType:  'Ip'
              patternValue: '192.168.178.0/24'
              interceptor:  'AccessGrant'

Protect an area of your application file based authentication and IP
check (only trigger authentication and entry points for clients with an
IP of ``127.0.0.1``)::

TYPO3:
    Flow:
      security:
        authentication:
          providers:
            'LocalNetworkProvider':
              provider: 'FileBasedSimpleKeyProvider'
              providerOptions:
                keyName: 'AdminKey'
                authenticateRoles: ['Acme.SomePackage:Administrator']
              requestPatterns:
                controllerObjectName: 'Acme\SomePackage\Controller\Administration\.*'
                ip: '::7F00:1'

Change-Id: I5494f0f90b563026cefda32a1763b3988316dcbf
Resolves: #49522
Releases: master, 3.0

Revision 2c1c4a32 - 2015-06-01 12:46 - Alexander Berl

[FEATURE] Request patterns for host name and IP addresses

This change adds RequestPatterns for host name and IP addresses.
Host names are configurable with a simple wildcard ('*') pattern, IP
addresses use ``CIDR`` style pattern with support for both ``IPv4`` and
``IPv6`` following ``RFC4632`` and ``RFC4291``.

Examples:

Only grant access to clients with IPs from 192.168.178.0 to
192.168.178.255::

TYPO3:
    Flow:
      security:
        firewall:
          rejectAll: TRUE
          filters:
            'ip':
              patternType:  'Ip'
              patternValue: '192.168.178.0/24'
              interceptor:  'AccessGrant'

Protect an area of your application file based authentication and IP
check (only trigger authentication and entry points for clients with an
IP of ``127.0.0.1``)::

TYPO3:
    Flow:
      security:
        authentication:
          providers:
            'LocalNetworkProvider':
              provider: 'FileBasedSimpleKeyProvider'
              providerOptions:
                keyName: 'AdminKey'
                authenticateRoles: ['Acme.SomePackage:Administrator']
              requestPatterns:
                controllerObjectName: 'Acme\SomePackage\Controller\Administration\.*'
                ip: '::7F00:1'

Change-Id: I5494f0f90b563026cefda32a1763b3988316dcbf
Resolves: #49522
Releases: master, 3.0

History
#1 - 2013-06-29 22:09 - Gerrit Code Review
- Status changed from New to Under Review

Patch set 1 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/21737

#2 - 2013-06-29 22:10 - Gerrit Code Review

Patch set 2 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/21737

#3 - 2014-06-11 16:30 - Gerrit Code Review

Patch set 3 for branch master of project Packages/TYPO3.Flow has been pushed to the review server.
It is available at https://review.typo3.org/21737

#4 - 2015-02-11 20:52 - Gerrit Code Review

Patch set 4 for branch master of project Packages/TYPO3.Flow has been pushed to the review server.
It is available at http://review.typo3.org/21737

#5 - 2015-05-29 18:12 - Gerrit Code Review

Patch set 5 for branch master of project Packages/TYPO3.Flow has been pushed to the review server.
It is available at http://review.typo3.org/21737

#6 - 2015-05-29 18:17 - Gerrit Code Review

Patch set 6 for branch master of project Packages/TYPO3.Flow has been pushed to the review server.
It is available at http://review.typo3.org/21737

#7 - 2015-05-29 18:22 - Gerrit Code Review

Patch set 7 for branch master of project Packages/TYPO3.Flow has been pushed to the review server.
It is available at http://review.typo3.org/21737

#8 - 2015-06-01 12:44 - Gerrit Code Review

Patch set 8 for branch master of project Packages/TYPO3.Flow has been pushed to the review server.
It is available at http://review.typo3.org/21737
#9 - 2015-06-01 12:45 - Gerrit Code Review

Patch set 9 for branch master of project Packages/TYPO3.Flow has been pushed to the review server.
It is available at http://review.typo3.org/21737

#10 - 2015-06-01 12:46 - Gerrit Code Review

Patch set 1 for branch 3.0 of project Packages/TYPO3.Flow has been pushed to the review server.
It is available at http://review.typo3.org/39858

#11 - 2015-06-01 13:00 - Alexander Berl
- Status changed from Under Review to Resolved
- % Done changed from 0 to 100

Applied in changeset commit:91dd1765514192f7dac2c526b9cd5de192afdb52.
